/*
Ŀ
                    SKYLZ EXEMPLE - HUFFMAN IN MEMORY                  
                                                                       
 Code : TuO & Ze KilleR / StG                         Date : 21/04/97  
                                                                       
 Note : This file shows how to use ENCODE/DECODE HUF functions with    
        memory-oriented methods.                                       
        First, we read the compressed datas and unpack them in memory  
        and then we  write the output file to  ensure that the memory  
        contains right datas...                                        
                                                                       
ٰ

*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <io.h>
#include "..\MAKELIB\SKYLZ.H"

void WriteFile(char *name,char *buf,unsigned long size)
{
  FILE *File;
  int amode;

  File = fopen(name, "wb");  // Open the new file...
  fwrite(buf,size,1,File);   // Write in...
  fclose(infile);            // Close it.
}

int main(int argc, char *argv[])
{
  char  *temp;       // Temporary buffer to get in the buffer

  printf("\nSkyLZ\n\nEX_HUF2\\EXAMPLE.C : Fast tutorial for memory packing/unpacking\n\n");

  if (argc != 4)     // We need 3 arguments!
  {
    printf("example e file1 file2 encodes file1 into file2\n"
           "example d file1 file2 decodes file1 into file2\n");
    return EXIT_FAILURE; // Na!
  }

  // Encode?
  if (toupper(*argv[1]) == 'E') EncodeHUF(argv[2],argv[3]);
  else
  {
    // No we have to decode file into memory!
    temp=DecodeHUFmem(argv[2]);

    /* Now it is a really important thing : the output buffer is returned by
       our good friend DecodeHUFmem, but unfortunately the size isn't.
       So you have to get it in with the textsize globale variable! */
    WriteFile(argv[3],temp,textsize);
  }
  return EXIT_SUCCESS; // All is OK
}
